//
// This file was generated by the JavaTM Architecture for XML Binding(JAXB) Reference Implementation, v2.2.4-2 
// See <a href="http://java.sun.com/xml/jaxb">http://java.sun.com/xml/jaxb</a> 
// Any modifications to this file will be lost upon recompilation of the source schema. 
// Generated on: 2015.06.09 at 11:11:31 AM CEST 
//


package net.ihe.gazelle.tempmodel.org.decor.art.model;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElements;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlSchemaType;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.bind.annotation.adapters.CollapsedStringAdapter;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;
import javax.xml.datatype.XMLGregorianCalendar;
import javax.xml.namespace.QName;

import net.ihe.gazelle.tempmodel.org.decor.art.behavior.HasItem;
import net.ihe.gazelle.tempmodel.org.decor.art.behavior.HasParent;
import net.ihe.gazelle.tempmodel.org.decor.art.utils.Pair;


/**
 * <p>Java class for RuleDefinition complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="RuleDefinition"&gt;
 *   &lt;complexContent&gt;
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType"&gt;
 *       &lt;sequence&gt;
 *         &lt;element name="desc" type="{}FreeFormMarkupWithLanguage" maxOccurs="unbounded" minOccurs="0"/&gt;
 *         &lt;element ref="{}item" minOccurs="0"/&gt;
 *         &lt;element ref="{}example" maxOccurs="unbounded" minOccurs="0"/&gt;
 *         &lt;element name="inherit" type="{}InheritDefinition" maxOccurs="0" minOccurs="0"/&gt;
 *         &lt;choice&gt;
 *           &lt;element ref="{}vocabulary" maxOccurs="unbounded" minOccurs="0"/&gt;
 *           &lt;element ref="{}property" maxOccurs="unbounded" minOccurs="0"/&gt;
 *         &lt;/choice&gt;
 *         &lt;element name="text" type="{}NonEmptyString" maxOccurs="unbounded" minOccurs="0"/&gt;
 *         &lt;element ref="{}attribute" maxOccurs="unbounded" minOccurs="0"/&gt;
 *         &lt;choice maxOccurs="unbounded"&gt;
 *           &lt;element ref="{}let" maxOccurs="unbounded" minOccurs="0"/&gt;
 *           &lt;element ref="{}assert" maxOccurs="unbounded" minOccurs="0"/&gt;
 *           &lt;element ref="{}report" maxOccurs="unbounded" minOccurs="0"/&gt;
 *           &lt;element ref="{}defineVariable" maxOccurs="unbounded" minOccurs="0"/&gt;
 *           &lt;element name="element" type="{}RuleDefinition" maxOccurs="unbounded" minOccurs="0"/&gt;
 *           &lt;element name="include" type="{}IncludeDefinition" maxOccurs="unbounded" minOccurs="0"/&gt;
 *           &lt;element name="choice" type="{}ChoiceDefinition" maxOccurs="unbounded" minOccurs="0"/&gt;
 *           &lt;element name="constraint" type="{}FreeFormMarkupWithLanguage" maxOccurs="unbounded" minOccurs="0"/&gt;
 *         &lt;/choice&gt;
 *       &lt;/sequence&gt;
 *       &lt;attGroup ref="{}MultiplicityRangeOptional"/&gt;
 *       &lt;attGroup ref="{}VersionHandlingEffectiveDateOptional"/&gt;
 *       &lt;attribute ref="{}displayName"/&gt;
 *       &lt;attribute name="statusCode" type="{}ItemStatusCodeLifeCycle" /&gt;
 *       &lt;attribute name="name" type="{http://www.w3.org/2001/XMLSchema}anyURI" /&gt;
 *       &lt;attribute name="useWhere" type="{http://www.w3.org/2001/XMLSchema}boolean" default="false" /&gt;
 *       &lt;attribute name="contains" type="{}BasicIdOrOid" /&gt;
 *       &lt;attribute name="flexibility" type="{}StaticOrDynamicFlexibility" default="dynamic" /&gt;
 *       &lt;attribute name="conformance" type="{}ConformanceType" /&gt;
 *       &lt;attribute name="isMandatory" type="{http://www.w3.org/2001/XMLSchema}boolean" default="false" /&gt;
 *       &lt;attribute name="id" type="{}Oid" /&gt;
 *       &lt;attribute name="datatype" type="{http://www.w3.org/2001/XMLSchema}QName" /&gt;
 *       &lt;attribute name="isClosed" type="{http://www.w3.org/2001/XMLSchema}boolean" default="false" /&gt;
 *       &lt;attribute name="strength" type="{}CodingStrengthType" default="CNE" /&gt;
 *     &lt;/restriction&gt;
 *   &lt;/complexContent&gt;
 * &lt;/complexType&gt;
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "RuleDefinition", propOrder = {
    "desc",
    "item",
    "example",
    "vocabulary",
    "property",
    "text",
    "attribute",
    "letOrAssertOrReport"
})
@XmlRootElement(name="RuleDefinitionType")
public class RuleDefinition implements HasItem,HasParent {

    private List<FreeFormMarkupWithLanguage> desc;
    private Item item;
    private List<Example> example;
    private List<Vocabulary> vocabulary;
    private List<Property> property;
    @XmlJavaTypeAdapter(CollapsedStringAdapter.class)
    private List<String> text;
    private List<Attribute> attribute;
    @XmlElements({
        @XmlElement(name = "let", type = Let.class),
        @XmlElement(name = "assert", type = Assert.class),
        @XmlElement(name = "report", type = Report.class),
        @XmlElement(name = "defineVariable", type = DefineVariable.class),
        @XmlElement(name = "element", type = RuleDefinition.class),
        @XmlElement(name = "include", type = IncludeDefinition.class),
        @XmlElement(name = "choice", type = ChoiceDefinition.class),
        @XmlElement(name = "constraint", type = FreeFormMarkupWithLanguage.class),
        @XmlElement(name = "contain", type = ContainDefinition.class)
    })
    private List<Object> letOrAssertOrReport;
    @XmlAttribute(name = "displayName")
    @XmlJavaTypeAdapter(CollapsedStringAdapter.class)
    private String displayName;
    @XmlAttribute(name = "statusCode")
    private ItemStatusCodeLifeCycle statusCode;
    @XmlAttribute(name = "name")
    @XmlSchemaType(name = "anyURI")
    private String name;
    @XmlAttribute(name = "useWhere")
    private Boolean useWhere;
    @XmlAttribute(name = "contains")
    private String contains;
    @XmlAttribute(name = "flexibility")
    private String flexibility;
    @XmlAttribute(name = "conformance")
    private ConformanceType conformance;
    @XmlAttribute(name = "isMandatory")
    private Boolean isMandatory;
    @XmlAttribute(name = "id")
    @XmlJavaTypeAdapter(CollapsedStringAdapter.class)
    private String id;
    @XmlAttribute(name = "datatype")
    private QName datatype;
    @XmlAttribute(name = "isClosed")
    private Boolean isClosed;
    @XmlAttribute(name = "strength")
    private CodingStrengthType strength;
    @XmlAttribute(name = "minimumMultiplicity")
    private Integer minimumMultiplicity;
    @XmlAttribute(name = "maximumMultiplicity")
    private String maximumMultiplicity;
    @XmlAttribute(name = "effectiveDate")
    private XMLGregorianCalendar effectiveDate;
    @XmlAttribute(name = "expirationDate")
    private XMLGregorianCalendar expirationDate;
    @XmlAttribute(name = "officialReleaseDate")
    private XMLGregorianCalendar officialReleaseDate;
    @XmlAttribute(name = "versionLabel")
    @XmlJavaTypeAdapter(CollapsedStringAdapter.class)
    private String versionLabel;
    
    @XmlTransient
	private Object parentObject;
    
    @XmlTransient
    private Pair<String, String> uniqueDistinguisher;
    
    @XmlTransient
    private Boolean hasDistinguisher;

    /**
     * Gets the value of the desc property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the desc property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getDesc().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link FreeFormMarkupWithLanguage }
     * 
     * 
     */
    public List<FreeFormMarkupWithLanguage> getDesc() {
        if (desc == null) {
            desc = new ArrayList<>();
        }
        return this.desc;
    }

    /**
     * Gets the value of the item property.
     * 
     * @return
     *     possible object is
     *     {@link Item }
     *     
     */
    public Item getItem() {
        return item;
    }

    /**
     * Sets the value of the item property.
     * 
     * @param value
     *     allowed object is
     *     {@link Item }
     *     
     */
    public void setItem(Item value) {
        this.item = value;
    }

    /**
     * Gets the value of the example property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the example property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getExample().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Example }
     * 
     * 
     */
    public List<Example> getExample() {
        if (example == null) {
            example = new ArrayList<>();
        }
        return this.example;
    }

    /**
     * Gets the value of the vocabulary property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the vocabulary property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getVocabulary().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Vocabulary }
     * 
     * 
     */
    public List<Vocabulary> getVocabulary() {
        if (vocabulary == null) {
            vocabulary = new ArrayList<>();
        }
        return this.vocabulary;
    }

    /**
     * Gets the value of the property property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the property property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getProperty().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Property }
     * 
     * 
     */
    public List<Property> getProperty() {
        if (property == null) {
            property = new ArrayList<>();
        }
        return this.property;
    }

    /**
     * Gets the value of the text property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the text property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getText().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link String }
     * 
     * 
     */
    public List<String> getText() {
        if (text == null) {
            text = new ArrayList<>();
        }
        return this.text;
    }

    /**
     * Gets the value of the attribute property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the attribute property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getAttribute().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Attribute }
     * 
     * 
     */
    public List<Attribute> getAttribute() {
        if (attribute == null) {
            attribute = new ArrayList<>();
        }
        return this.attribute;
    }

    /**
     * Gets the value of the letOrAssertOrReport property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the letOrAssertOrReport property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getLetOrAssertOrReport().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Let }
     * {@link Assert }
     * {@link Report }
     * {@link DefineVariable }
     * {@link RuleDefinition }
     * {@link IncludeDefinition }
     * {@link ChoiceDefinition }
     * {@link FreeFormMarkupWithLanguage }
     * 
     * 
     */
    public List<Object> getLetOrAssertOrReport() {
        if (letOrAssertOrReport == null) {
            letOrAssertOrReport = new ArrayList<>();
        }
        return this.letOrAssertOrReport;
    }

    /**
     * Gets the value of the displayName property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getDisplayName() {
        return displayName;
    }

    /**
     * Sets the value of the displayName property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setDisplayName(String value) {
        this.displayName = value;
    }

    /**
     * Gets the value of the statusCode property.
     * 
     * @return
     *     possible object is
     *     {@link ItemStatusCodeLifeCycle }
     *     
     */
    public ItemStatusCodeLifeCycle getStatusCode() {
        return statusCode;
    }

    /**
     * Sets the value of the statusCode property.
     * 
     * @param value
     *     allowed object is
     *     {@link ItemStatusCodeLifeCycle }
     *     
     */
    public void setStatusCode(ItemStatusCodeLifeCycle value) {
        this.statusCode = value;
    }

    /**
     * Gets the value of the name property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getName() {
        return name;
    }

    /**
     * Sets the value of the name property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setName(String value) {
        this.name = value;
    }

    /**
     * Gets the value of the useWhere property.
     * 
     * @return
     *     possible object is
     *     {@link Boolean }
     *     
     */
    public boolean isUseWhere() {
        if (useWhere == null) {
            return false;
        } else {
            return useWhere;
        }
    }

    /**
     * Sets the value of the useWhere property.
     * 
     * @param value
     *     allowed object is
     *     {@link Boolean }
     *     
     */
    public void setUseWhere(Boolean value) {
        this.useWhere = value;
    }

    /**
     * Gets the value of the contains property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getContains() {
        return contains;
    }

    /**
     * Sets the value of the contains property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setContains(String value) {
        this.contains = value;
    }

    /**
     * Gets the value of the flexibility property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getFlexibility() {
        if (flexibility == null) {
            return "dynamic";
        } else {
            return flexibility;
        }
    }

    /**
     * Sets the value of the flexibility property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setFlexibility(String value) {
        this.flexibility = value;
    }

    /**
     * Gets the value of the conformance property.
     * 
     * @return
     *     possible object is
     *     {@link ConformanceType }
     *     
     */
    public ConformanceType getConformance() {
        return conformance;
    }

    /**
     * Sets the value of the conformance property.
     * 
     * @param value
     *     allowed object is
     *     {@link ConformanceType }
     *     
     */
    public void setConformance(ConformanceType value) {
        this.conformance = value;
    }

    /**
     * Gets the value of the isMandatory property.
     * 
     * @return
     *     possible object is
     *     {@link Boolean }
     *     
     */
    public boolean isIsMandatory() {
        if (isMandatory == null) {
            return false;
        } else {
            return isMandatory;
        }
    }
    
    public Boolean getIsMandatory() {
    	return isMandatory;
    }

    /**
     * Sets the value of the isMandatory property.
     * 
     * @param value
     *     allowed object is
     *     {@link Boolean }
     *     
     */
    public void setIsMandatory(Boolean value) {
        this.isMandatory = value;
    }

    /**
     * Gets the value of the id property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getId() {
        return id;
    }

    /**
     * Sets the value of the id property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setId(String value) {
        this.id = value;
    }

    /**
     * Gets the value of the datatype property.
     * 
     * @return
     *     possible object is
     *     {@link QName }
     *     
     */
    public QName getDatatype() {
        return datatype;
    }

    /**
     * Sets the value of the datatype property.
     * 
     * @param value
     *     allowed object is
     *     {@link QName }
     *     
     */
    public void setDatatype(QName value) {
        this.datatype = value;
    }

    /**
     * Gets the value of the isClosed property.
     * 
     * @return
     *     possible object is
     *     {@link Boolean }
     *     
     */
    public boolean isIsClosed() {
        if (isClosed == null) {
            return false;
        } else {
            return isClosed;
        }
    }
    
    public Boolean getIsClosed() {
    	return isClosed;
    }

    /**
     * Sets the value of the isClosed property.
     * 
     * @param value
     *     allowed object is
     *     {@link Boolean }
     *     
     */
    public void setIsClosed(Boolean value) {
        this.isClosed = value;
    }

    /**
     * Gets the value of the strength property.
     * 
     * @return
     *     possible object is
     *     {@link CodingStrengthType }
     *     
     */
    public CodingStrengthType getStrength() {
        if (strength == null) {
            return CodingStrengthType.required;
        } else {
            return strength;
        }
    }

    /**
     * Sets the value of the strength property.
     * 
     * @param value
     *     allowed object is
     *     {@link CodingStrengthType }
     *     
     */
    public void setStrength(CodingStrengthType value) {
        this.strength = value;
    }

    /**
     * Gets the value of the minimumMultiplicity property.
     * 
     * @return
     *     possible object is
     *     {@link Integer }
     *     
     */
    public Integer getMinimumMultiplicity() {
        return minimumMultiplicity;
    }

    /**
     * Sets the value of the minimumMultiplicity property.
     * 
     * @param value
     *     allowed object is
     *     {@link Integer }
     *     
     */
    public void setMinimumMultiplicity(Integer value) {
        this.minimumMultiplicity = value;
    }

    /**
     * Gets the value of the maximumMultiplicity property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getMaximumMultiplicity() {
        return maximumMultiplicity;
    }

    /**
     * Sets the value of the maximumMultiplicity property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setMaximumMultiplicity(String value) {
        this.maximumMultiplicity = value;
    }

    /**
     * Gets the value of the effectiveDate property.
     * 
     * @return
     *     possible object is
     *     {@link XMLGregorianCalendar }
     *     
     */
    public XMLGregorianCalendar getEffectiveDate() {
        return effectiveDate;
    }

    /**
     * Sets the value of the effectiveDate property.
     * 
     * @param value
     *     allowed object is
     *     {@link XMLGregorianCalendar }
     *     
     */
    public void setEffectiveDate(XMLGregorianCalendar value) {
        this.effectiveDate = value;
    }

    /**
     * Gets the value of the expirationDate property.
     * 
     * @return
     *     possible object is
     *     {@link XMLGregorianCalendar }
     *     
     */
    public XMLGregorianCalendar getExpirationDate() {
        return expirationDate;
    }

    /**
     * Sets the value of the expirationDate property.
     * 
     * @param value
     *     allowed object is
     *     {@link XMLGregorianCalendar }
     *     
     */
    public void setExpirationDate(XMLGregorianCalendar value) {
        this.expirationDate = value;
    }

    /**
     * Gets the value of the officialReleaseDate property.
     * 
     * @return
     *     possible object is
     *     {@link XMLGregorianCalendar }
     *     
     */
    public XMLGregorianCalendar getOfficialReleaseDate() {
        return officialReleaseDate;
    }

    /**
     * Sets the value of the officialReleaseDate property.
     * 
     * @param value
     *     allowed object is
     *     {@link XMLGregorianCalendar }
     *     
     */
    public void setOfficialReleaseDate(XMLGregorianCalendar value) {
        this.officialReleaseDate = value;
    }

    /**
     * Gets the value of the versionLabel property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getVersionLabel() {
        return versionLabel;
    }

    /**
     * Sets the value of the versionLabel property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setVersionLabel(String value) {
        this.versionLabel = value;
    }

	@SuppressWarnings("unchecked")
	public Object getParentObject() {
		return parentObject;
	}

	public void setParentObject(Object parentComponent) {
		this.parentObject = parentComponent;
	}
	
	public Pair<String, String> getUniqueDistinguisher() {
		return uniqueDistinguisher;
	}

	public void setUniqueDistinguisher(Pair<String, String> uniqueDistinguisher) {
		this.uniqueDistinguisher = uniqueDistinguisher;
	}

	public Boolean getHasDistinguisher() {
		return hasDistinguisher;
	}

	public void setHasDistinguisher(Boolean hasDistinguisher) {
		this.hasDistinguisher = hasDistinguisher;
	}

	void afterUnmarshal( javax.xml.bind.Unmarshaller u, Object parent ){
		this.parentObject = parent;
	}

}
